﻿using DotNetCore.CAP;
using MapsterMapper;
using Push.Share;
using Push.Share.Dtos;
using XF.Domain.Dependency;

namespace Push.YiBin.Application;

public class EventSubscriber : ICapSubscribe, ITransientDependency
{
    private readonly IPushDomainService _pushDomainService;
    private readonly IMapper _mapper;

    public EventSubscriber(IPushDomainService pushDomainService, IMapper mapper)
    {
        _pushDomainService = pushDomainService;
        _mapper = mapper;
    }

    [CapSubscribe(EventNames.SendSms)]
    public async Task PushSmsAsync(MessageDto dto, CancellationToken cancellationToken)
    {
        // await _pushDomainService.PushAsync(dto, cancellationToken);
        await _pushDomainService.PushAddWaitMessage(_mapper.Map<WaitMessage>(dto), cancellationToken);
    }
}