﻿using Push.Share.Dtos;
using Push.Share.Dtos.FWMessage;
using Push.YiBin.Dtos;

namespace Push.YiBin
{
    public interface IPushDomainService
    {
        /// <summary>
        /// 写入待发表
        /// </summary>
        /// <param name="dto"></param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task PushAddWaitMessage(WaitMessage dto, CancellationToken cancellation);

        /// <summary>
        /// 消息队列发送
        /// </summary>
        /// <param name="messageDto"></param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task<Message> PushMessageNewAsync(Share.Dtos.MessageDto messageDto, CancellationToken cancellation);

        /// <summary>
        /// 短信发送
        /// </summary>
        /// <param name="messageDto"></param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task PushAsync(MessageDto messageDto, CancellationToken cancellation);

        /// <summary>
        /// 查询短信剩余数量
        /// </summary>
        /// <returns></returns>
        Task<string> GetAccountNum();

        /// <summary>
        /// 短信发送状态回调接口
        /// </summary>
        /// <param name="receiveMessageDto"></param>
        /// <returns></returns>
        Task<string> ReceiveObtain(ReceiveMessageDto receiveMessageDto);

        /// <summary>
        /// 短信接收
        /// </summary>
        /// <param name="receiveMessageDto"></param>
        /// <returns></returns>
        Task<string> ReceiveSms(ReceiveMessageDto receiveMessageDto);
    }
}
